#include "fmtstr.h"

void fmtstr(char *dest, const char *src, const struct fmt_option *opts)
{
	int sp = 0, dp = 0, i = 0;
	int percent = 0;

	for (sp=dp=0; src[sp]!='\0'; sp++) {
		if (percent) {
			if (src[sp]=='%') {
				dest[dp++] = '%';
			}
			else {
				for (i=0; opts[i].opt; i++)
					if (opts[i].opt==src[sp]) {
						strcpy(&dest[dp], opts[i].str);
						dp+=strlen(opts[i].str);
						break;
					}
				if (!opts[i].opt) {
					dest[dp++] = '%';
					dest[dp++] = src[sp];
				}
			}
			percent = 0;
		}
		else {
			if (src[sp]=='%') percent = 1;
			else dest[dp++] = src[sp];
		}
	}
	dest[dp] = '\0';
}
